const beforeUnloadHandler = (event) => {
  event.preventDefault();
};

const forms = document.querySelectorAll("form");

for (let form of forms) {
  let inputs = form.querySelectorAll("input");
  for (input of inputs) {
    input.addEventListener("input", (event) => {
      window.addEventListener("beforeunload", beforeUnloadHandler);
    });
  }

  form.addEventListener("submit", (event) => {
    window.removeEventListener("beforeunload", beforeUnloadHandler);
  });
  form.addEventListener("reset", (event) => {
    window.removeEventListener("beforeunload", beforeUnloadHandler);
  });

  let categorySelect = form.querySelector(".category-select");
  if (categorySelect) {
    let input = categorySelect.querySelector("select");
    let icon = categorySelect.querySelector("span");
    let icons = JSON.parse(input.dataset.icons);

    function setIcon(event) {
      icon.className = `ri-${icons[input.value] || "folder"}-line`;
    }
    setIcon();
    input.addEventListener("input", setIcon);
    form.addEventListener("reset", (event) => {
      setTimeout(setIcon, 0);
    });
  }

  let iconSelect = form.querySelector(".icon-select");
  if (iconSelect) {
    let input = iconSelect.querySelector("input");
    let icon = iconSelect.querySelector("span");
    let icons = Array.from(iconSelect.querySelector("datalist").options).map(
      (opt) => opt.value,
    );

    function setIcon(event) {
      console.log(input.value);
      icon.className = `ri-${
        icons.includes(input.value) ? input.value : "square"
      }-line`;
    }
    setIcon();
    input.addEventListener("input", setIcon);
    form.addEventListener("reset", (event) => {
      setTimeout(setIcon, 0);
    });
  }
}

let accounts = document.querySelector("dl.accounts");
if (accounts) {
  let toggle = accounts.querySelector("input#show-archived-accounts");
  if (toggle) {
    accounts.classList.toggle("show-archive", toggle.checked);
    toggle.addEventListener("change", (event) => {
      accounts.classList.toggle("show-archive", toggle.checked);
    });
  }
}
